/* afh5c.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int afh5c_c(integer *nm, integer *n, real *a, real *d__,
        real *e, real *e2, real *tau)
{
    /* Initialized data */

    static real sys056 = 1.175495e-38f; /* = sys055 */

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3;
    real r__1, r__2;
    complex q__1;

    /* Builtin functions */
    double sqrt(doublereal), c_abs(complex *);

    /* Local variables */
    static real f, g, h__;
    static integer i__, j, k, l;
    static real scale, fi, gi, hh;
    static integer ii;
    static real si;
    static integer jm1, jp1;


#define a_subscr(a_1,a_2) (a_2)*a_dim1 + a_1
#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define tau_ref(a_1,a_2) tau[(a_2)*2 + a_1]

    /* Parameter adjustments */
    tau -= 3;
    --e2;
    --e;
    --d__;
    a_dim1 = *nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;

    /* Function Body */
    tau_ref(1, *n) = 1.f;
    tau_ref(2, *n) = 0.f;
/*     I=N,1,-1 */
    i__1 = *n;
    for (ii = 1; ii <= i__1; ++ii) {
        i__ = *n + 1 - ii;
        l = i__ - 1;
        h__ = 0.f;
        scale = 0.f;
        if (l < 1) {
            goto L30;
        }
/*     HOPMPOBKA CTPOK */
        i__2 = l;
        for (k = 1; k <= i__2; ++k) {
            scale = scale + (r__1 = a_ref(i__, k), abs(r__1)) + (r__2 =
                    a_ref(k, i__), abs(r__2));
/* L10: */
        }
        if (scale >= sys056) {
            goto L40;
        }
        tau_ref(1, l) = 1.f;
        tau_ref(2, l) = 0.f;
        i__2 = l;
        for (k = 1; k <= i__2; ++k) {
            a_ref(i__, k) = 0.f;
            a_ref(k, i__) = 0.f;
/* L20: */
        }
L30:
        e[i__] = 0.f;
        e2[i__] = 0.f;
        goto L170;
L40:
        i__2 = l;
        for (k = 1; k <= i__2; ++k) {
            a_ref(i__, k) = a_ref(i__, k) / scale;
            a_ref(k, i__) = a_ref(k, i__) / scale;
            h__ = h__ + a_ref(i__, k) * a_ref(i__, k) + a_ref(k, i__) *
                    a_ref(k, i__);
/* L50: */
        }
        e2[i__] = scale * scale * h__;
        g = (real)sqrt(h__);
        e[i__] = scale * g;
        i__2 = a_subscr(i__, l);
        i__3 = a_subscr(l, i__);
        q__1.r = a[i__2], q__1.i = a[i__3];
        f = (real)c_abs(&q__1);
/* OPM-E CEYEO A.EMEHTA MATP T */
        if (f <= sys056) {
            goto L60;
        }
        tau_ref(1, l) = (a_ref(l, i__) * tau_ref(2, i__) - a_ref(i__, l) * 
                tau_ref(1, i__)) / f;
        si = (a_ref(i__, l) * tau_ref(2, i__) + a_ref(l, i__) *
                tau_ref(1, i__)) / f;
        h__ += f * g;
        g = g / f + 1.f;
        a_ref(i__, l) = g * a_ref(i__, l);
        a_ref(l, i__) = g * a_ref(l, i__);
        if (l == 1) {
            goto L150;
        }
        goto L70;
L60:
        tau_ref(1, l) = -tau_ref(1, i__);
        si = tau_ref(2, i__);
        a_ref(l, i__) = 0.f;
        a_ref(i__, l) = g;
L70:
        f = 0.f;
        i__2 = l;
        for (j = 1; j <= i__2; ++j) {
            g = 0.f;
            gi = 0.f;
            if (j == 1) {
                goto L90;
            }
            jm1 = j - 1;
/* OPM-E A*U */
            i__3 = jm1;
            for (k = 1; k <= i__3; ++k) {
                g = g + a_ref(j, k) * a_ref(i__, k) + a_ref(k, j) *
                        a_ref(k, i__);
                gi = gi - a_ref(j, k) * a_ref(k, i__) + a_ref(k, j) *
                        a_ref(i__, k);
/* L80: */
            }
L90:
            g += a_ref(j, j) * a_ref(i__, j);
            gi -= a_ref(j, j) * a_ref(j, i__);
            jp1 = j + 1;
            if (l < jp1) {
                goto L110;
            }
            i__3 = l;
            for (k = jp1; k <= i__3; ++k) {
                g = g + a_ref(k, j) * a_ref(i__, k) - a_ref(j, k) *
                        a_ref(k, i__);
                gi = gi - a_ref(k, j) * a_ref(k, i__) - a_ref(j, k) *
                        a_ref(i__, k);
/* L100: */
            }
/* OPM-E P */
L110:
            e[j] = g / h__;
            tau_ref(2, j) = gi / h__;
            f = f + e[j] * a_ref(i__, j) - tau_ref(2, j) * a_ref(j, i__);
/* L120: */
        }
        hh = f / (h__ + h__);
/* PEOPAOBAHE MACCBA A */
        i__2 = l;
        for (j = 1; j <= i__2; ++j) {
            f = a_ref(i__, j);
            g = e[j] - hh * f;
            e[j] = g;
            fi = -a_ref(j, i__);
            gi = tau_ref(2, j) - hh * fi;
            tau_ref(2, j) = -gi;
            a_ref(j, j) = a_ref(j, j) - (f * g + fi * gi) * 2.f;
            if (j == 1) {
                goto L140;
            }
            jm1 = j - 1;
            i__3 = jm1;
            for (k = 1; k <= i__3; ++k) {
                a_ref(j, k) = a_ref(j, k) - f * e[k] - g * a_ref(i__, k) + fi 
                        * tau_ref(2, k) + gi * a_ref(k, i__);
                a_ref(k, j) = a_ref(k, j) - f * tau_ref(2, k) - g *
                        a_ref(k, i__) - fi * e[k] - gi * a_ref(i__, k);
/* L130: */
            }
L140:
            ;
        }
L150:
        i__2 = l;
        for (k = 1; k <= i__2; ++k) {
            a_ref(i__, k) = scale * a_ref(i__, k);
            a_ref(k, i__) = scale * a_ref(k, i__);
/* L160: */
        }
        tau_ref(2, l) = -si;
L170:
        d__[i__] = a_ref(i__, i__);
        a_ref(i__, i__) = scale * (real)sqrt(h__);
/* L180: */
    }
    return 0;
} /* afh5c_c */

#undef tau_ref
#undef a_ref
#undef a_subscr
